SystemOrganization addCategory: #InteractiveBisect!

TestCase subclass: #InteractiveBisectTest
	instanceVariableNames: 'bisect gotTooSmallNumberChanged gotTooBigNumberChanged gotNumberChanged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InteractiveBisect'!

!InteractiveBisectTest methodsFor: 'running' stamp: 'hjo 4/29/2012 15:14'!
setUp

	super setUp.
	gotTooSmallNumberChanged := false.
	gotNumberChanged := false.
	gotTooBigNumberChanged := false.
	bisect := InteractiveBisect new.
	bisect addDependent: self.! !

!InteractiveBisectTest methodsFor: 'running' stamp: 'hjo 8/30/2011 20:19'!
tearDown

	bisect breakDependents.
	super tearDown.! !

!InteractiveBisectTest methodsFor: 'tests' stamp: 'hjo 8/2/2011 12:37'!
testIntegerMode

	self deny: bisect isIntegerMode.
	bisect beIntegerMode.
	self assert: bisect isIntegerMode.

	bisect inputNumber: 0.4.
	bisect treatTheNumberTooSmall.
	self assert: (bisect stringOfInputNumber) equals: '0'. "0.4 is truncated to 0"

	bisect inputNumber: 15.655.
	bisect treatTheNumberTooBig.
	self assert: (bisect stringOfInputNumber) equals: '7'. "(int)((0.0+15.0)/2)"
	bisect treatTheNumberTooBig.
	self assert: (bisect stringOfInputNumber) equals: '3'. "(int)((0.0+7.0)/2)"
	bisect treatTheNumberTooSmall.
	self assert: (bisect stringOfInputNumber) equals: '5'. "(int)((3.0+7.0)/2)"
	bisect treatTheNumberTooBig.
	self assert: (bisect stringOfInputNumber) equals: '4'. "(int)((3.0+5.0)/2)"! !

!InteractiveBisectTest methodsFor: 'tests' stamp: 'hjo 4/29/2012 15:16'!
testReset

	bisect inputNumber: 10.0.
	bisect treatTheNumberTooBig.
	bisect inputNumber: 0.0.
	bisect treatTheNumberTooSmall.
	gotNumberChanged := false.
	bisect reset.
	self assert: gotNumberChanged.
	self assert: bisect inputNumber isNil.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: ''.
	self assert: bisect stringOfTooBigNumber equals: ''.

	gotNumberChanged := false.
	bisect inputNumber: 6.0.
	bisect treatTheNumberTooSmall.
	self deny: gotNumberChanged.
	self assert: (bisect stringOfInputNumber) equals: '6.0'.
! !

!InteractiveBisectTest methodsFor: 'tests' stamp: 'hjo 8/1/2011 23:07'!
testSetUp

	self assert: bisect notNil! !

!InteractiveBisectTest methodsFor: 'tests-basic' stamp: 'hjo 4/29/2012 15:17'!
testTooBig

	bisect inputNumber: 0.0.
	bisect treatTheNumberTooBig.
	self deny: gotNumberChanged.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: '0.0'.
	self assert: bisect stringOfTooBigNumber equals: '0.0'.! !

!InteractiveBisectTest methodsFor: 'tests' stamp: 'hjo 4/29/2012 15:14'!
testTooBigTooSmall

	bisect inputNumber: 10.0.
	bisect treatTheNumberTooBig.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: '10.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.
	
	bisect inputNumber: 0.0.
	bisect treatTheNumberTooSmall.
	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '5.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	self assert: gotNumberChanged.
	self assert: bisect inputNumber asNumber equals: 5.0.  
	"STAssertEqualsWithAccuracy(5.0, [[binarySearch inputNumber] doubleValue], 0.0001, nil);"! !

!InteractiveBisectTest methodsFor: 'tests' stamp: 'hjo 4/29/2012 15:14'!
testTooBigTooSmallTooBig

	bisect inputNumber: 10.0.
	bisect treatTheNumberTooBig.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: '10.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	bisect inputNumber: 0.0.
	bisect treatTheNumberTooSmall.

	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '5.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	gotNumberChanged := false.
	bisect treatTheNumberTooBig.
	self assert: gotNumberChanged.
	self assert: (bisect inputNumber asNumber) equals: 2.5.
	"STAssertEqualsWithAccuracy(2.5, [[bisect inputNumber] doubleValue], 0.0001, nil);"
	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '2.5'.
	self assert: bisect stringOfTooBigNumber equals: '5.0'.
! !

!InteractiveBisectTest methodsFor: 'tests' stamp: 'hjo 4/29/2012 15:21'!
testTooBigTooSmallTooSmall

	bisect inputNumber: 10.0.
	bisect treatTheNumberTooBig.
	self assert: bisect stringOfTooSmallNumber equals: ''.
	self assert: bisect stringOfInputNumber equals: '10.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	bisect inputNumber: 0.0.
	bisect treatTheNumberTooSmall.
	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '5.0'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.

	gotNumberChanged := false.
	bisect treatTheNumberTooSmall.
	self assert: gotNumberChanged.
	self assert: (bisect inputNumber asNumber) equals: 7.5.
	"STAssertEqualsWithAccuracy(7.5, [[bisect inputNumber] doubleValue], 0.0001, nil);"
	self assert: bisect stringOfTooSmallNumber equals: '5.0'.
	self assert: bisect stringOfInputNumber equals: '7.5'.
	self assert: bisect stringOfTooBigNumber equals: '10.0'.
! !

!InteractiveBisectTest methodsFor: 'tests-basic' stamp: 'hjo 4/29/2012 15:17'!
testTooSmall

	bisect inputNumber: 0.0.
	bisect treatTheNumberTooSmall.
	self deny: gotNumberChanged.  
	self assert: bisect stringOfTooSmallNumber equals: '0.0'.
	self assert: bisect stringOfInputNumber equals: '0.0'.
	self assert: bisect stringOfTooBigNumber equals: ''. 
! !

!InteractiveBisectTest methodsFor: 'updating' stamp: 'hjo 4/29/2012 15:14'!
update: aSymbol

	super update: aSymbol.  
	aSymbol == #inputNumber ifTrue: [ gotNumberChanged := true. ].
	aSymbol == #tooSmallNumber ifTrue: [ gotTooSmallNumberChanged := true. ].
	aSymbol == #tooBigNumber ifTrue: [ gotTooBigNumberChanged := true. ].! !

Object subclass: #InteractiveBisect
	instanceVariableNames: 'integerMode inputNumber tooSmallNumber tooBigNumber controllingBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InteractiveBisect'!

!InteractiveBisect methodsFor: 'changing' stamp: 'hjo 8/2/2011 11:31'!
beIntegerMode

	self integerMode: true! !

!InteractiveBisect methodsFor: 'helper' stamp: 'hjo 4/28/2012 20:49'!
control

	controllingBlock notNil ifTrue: 
	[
		controllingBlock value: self inputNumber.
	]! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 4/28/2012 20:45'!
controllingBlock

	^controllingBlock! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 4/28/2012 20:45'!
controllingBlock: aBlock

	controllingBlock := aBlock.! !

!InteractiveBisect methodsFor: 'defaults' stamp: 'hjo 8/2/2011 11:27'!
defaultForIntegerMode

	^false! !

!InteractiveBisect methodsFor: 'helper' stamp: 'hjo 8/2/2011 12:54'!
inputMiddleNumber
	self inputNumber: (tooSmallNumber + tooBigNumber) / 2.0! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 8/2/2011 12:36'!
inputNumber

	^inputNumber! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 8/2/2011 12:38'!
inputNumber: aNumber 

	inputNumber := self numberToSet: aNumber! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 8/2/2011 11:26'!
integerMode

	^integerMode setDefault: #defaultForIntegerMode for: self   withSetter: #integerMode:   ! !

!InteractiveBisect methodsFor: 'accessing' stamp: 'hjo 4/29/2012 15:46'!
integerMode: aBoolean 

	integerMode := aBoolean.
	aBoolean ifTrue: 
		[
			tooSmallNumber notNil ifTrue: [
				tooSmallNumber := tooSmallNumber truncated.
				self changed: #tooSmallNumber.
				self changed: #stringOfTooSmallNumber.].
			tooBigNumber notNil ifTrue: [
				tooBigNumber := tooBigNumber truncated.
				self changed: #tooBigNumber.
				self changed: #stringOfTooBigNumber.].
			inputNumber notNil ifTrue: [
				inputNumber := inputNumber truncated.
				self changed: #inputNumber.].  
		]! !

!InteractiveBisect methodsFor: 'testing' stamp: 'hjo 8/2/2011 11:27'!
isIntegerMode

	^self integerMode! !

!InteractiveBisect methodsFor: 'helper' stamp: 'hjo 8/2/2011 11:39'!
numberToSet: aFloat 

	^self isIntegerMode ifTrue: [aFloat truncated] ifFalse: [aFloat]! !

!InteractiveBisect methodsFor: 'morph' stamp: 'hjo 4/29/2012 15:58'!
open

	| b small input big row1 row2 buttonSmall buttonBig integerCheckbox win resetButton spacer topSpace |
	b := UITheme builder.
	small := b newLabelFor: self getLabel: #stringOfTooSmallNumber getEnabled: nil.
	input := b newTextEntryFor: self getText: #inputNumber setText: #inputNumber: help: 'input number'.
	big := b newLabelFor: self getLabel: #stringOfTooBigNumber getEnabled: nil.
	row1 := b newRow: {small . input . big}.
	
	spacer := b newPanel.
	spacer extent: 200@20.
	
	topSpace := b newPanel.
	topSpace extent: 200@20.
	
	buttonSmall := b newButtonFor: self action: #treatTheNumberTooSmall label: 'too small' help: 'press this button if the number is too small.'.
	buttonBig := b newButtonFor: self action: #treatTheNumberTooBig label: 'too big' help: 'press this button if the number is too big.'.
	integerCheckbox := b newCheckboxFor: self getSelected: #integerMode setSelected: #integerMode: label: 'integer' help: 'integer mode'.
	resetButton := b newButtonFor: self action: #reset label: 'reset' help: 'start all over'.
	
	row2 := b newRow: {integerCheckbox. buttonSmall. buttonBig. resetButton}.
	win := (b newColumn: {topSpace. row1. spacer. row2}) openInWindowLabeled: 'InteractiveBisect'.
	win extent:  (299@161).! !

!InteractiveBisect methodsFor: 'changing' stamp: 'hjo 4/29/2012 15:47'!
reset
	inputNumber := nil.
	tooSmallNumber := nil.
	tooBigNumber := nil.

	self changed: #inputNumber.
	self changed: #tooSmallNumber.
	self changed: #stringOfTooSmallNumber.
	self changed: #tooBigNumber.
	self changed: #stringOfTooBigNumber.! !

!InteractiveBisect methodsFor: 'printing' stamp: 'hjo 8/2/2011 12:48'!
stringOfInputNumber

	^self stringOrNullString: inputNumber  ! !

!InteractiveBisect methodsFor: 'printing' stamp: 'hjo 8/2/2011 12:49'!
stringOfTooBigNumber

	^self stringOrNullString: tooBigNumber  ! !

!InteractiveBisect methodsFor: 'printing' stamp: 'hjo 8/2/2011 12:49'!
stringOfTooSmallNumber

	^self stringOrNullString: tooSmallNumber  ! !

!InteractiveBisect methodsFor: 'helper' stamp: 'hjo 4/29/2012 15:26'!
stringOrNullString: aNumber

	^aNumber isNil 
		ifTrue: [ '' ]
		ifFalse: [ |fl m sci|
			aNumber isZero 
				ifTrue: [aNumber printString]
				ifFalse: [
					fl :=  aNumber abs floorLog: 10.
					m := aNumber / (10 raisedTo: fl).
					sci := (m printString copyFrom: 1 to: (m printString size min: 5)), 'e' , (fl printString).
					aNumber printString size > sci size
						ifTrue: [sci]
						ifFalse: [aNumber printString]] ]! !

!InteractiveBisect methodsFor: 'changing' stamp: 'hjo 4/29/2012 15:48'!
treatTheNumberTooBig

	tooBigNumber := self inputNumber.
	self changed: #tooBigNumber.
	self changed: #stringOfTooBigNumber.
	self tryToControlWithComputedNumber! !

!InteractiveBisect methodsFor: 'changing' stamp: 'hjo 4/29/2012 15:48'!
treatTheNumberTooSmall

	tooSmallNumber := self inputNumber.
	self changed: #tooSmallNumber.
	self changed: #stringOfTooSmallNumber.
	self tryToControlWithComputedNumber! !

!InteractiveBisect methodsFor: 'helper' stamp: 'hjo 4/29/2012 15:27'!
tryToControlWithComputedNumber
	(tooSmallNumber notNil and: [ tooBigNumber notNil ])
		ifTrue: [ 
			self inputMiddleNumber.
			self control.
			self changed: #inputNumber   ]! !
